#########################################################################
#File Description: 
#This file generates Table 4.6
#########################################################################

#***********************************************************************
#**************LIBRARIES AND WORKING DIRECTORY**************************
#***********************************************************************
setwd("H:/DingBook/Files Sharing/") #modify accordingly
##Functions to import
source("Code Used in the Book/Chapter4/funcs/bin_est.R")

#***********************************************************************
#************PARAMETERS TO BE SPECIFICED BY USER************************
#***********************************************************************
roll.int=6# amount by which we translate every roll
r_speeds = c(0.00, 4.50, 9.00) #refined speed thresholds
r_dirs = c(45,225) #refined direction thresholds
num_regimes = 6 #number of regimes
infpt = 9.5 #inflection point in power curve
vco = 20 #cutout speed 
vr = 13.5 #rated speed
vci = 3.5 #cutin speed
num_regimes = 6 #number of regimes

#################################################################################
####################  IMPORTING DATA  ###########################################
#################################################################################
rawdata <- read.csv("Data Used in the Book/Wind Spatio-Temporal Dataset2.csv",as.is=T,header=T) #import data
training_period = 365 #days
Period = training_period*24 #hours
N = 200 #number of turbines

##restructuring data
dd <- matrix(nrow=(Period*N),ncol=3)
indices = seq(2,400,2)
aa = 1
for(i in 1:Period){
  dd[aa:(aa+N-1),1] = seq(1,N,1)
  dd[aa:(aa+N-1),2] = as.numeric(rawdata[i+4,indices])
  dd[aa:(aa+N-1),3] = as.numeric(rawdata[i+4,indices+1])
  aa = aa + N
}
dd = as.data.frame(dd)
colnames(dd) = c("id","Speed","Power")
datas = dd[1:(training_period*24*N),] #Selecting training dataset

#Coordinates of turbines
coords = matrix(nrow=N,ncol=3)
coords[,1] = seq(1,N,1)
coords[,2] = as.numeric(rawdata[1,2:201])
coords[,3] = as.numeric(rawdata[2,2:201])
coords = as.data.frame(coords)
colnames(coords) = c("id","lat","long")

#Restructuring Mast data
num_masts = 3
coords_mast = matrix(nrow=num_masts,ncol=3)
coords_mast[,1] = seq(1,num_masts,1)
coords_mast[,2] = as.numeric(rawdata[1,202:204])
coords_mast[,3] = as.numeric(rawdata[2,202:204])
coords_mast = as.data.frame(coords_mast)
colnames(coords_mast) = c("id","lat","long")
dirs = speed.masts = matrix(nrow=Period,ncol=num_masts) #direction data from masts
indices = c(402,404,406)
for(i in 1:num_masts){
  speed.masts[,i] = as.numeric(rawdata[ 5:(Period+4),indices[i]])
  dirs[,i] = as.numeric(rawdata[5:(Period+4),indices[i]+1])
}
colnames(dirs) = colnames(speed.masts) = c("m1","m2","m3")

load("Code Used in the Book/Chapter4/temp/trainout_test.R")
load("Code Used in the Book/Chapter4/temp/predout_test.R")
load("Code Used in the Book/Chapter4/temp/indicesout_test.R")

########################################################################################
############TURBINE-SPECIFIC POWER ESTIMATION USING BINNING METHOD######################
########################################################################################
output.list = bin_est(datas,bw=.5,cutin = vci,rated = vr,numturbs = N)
vbin = as.numeric(output.list[[1]])
P.est = output.list[[2]]

##########################################################################
########### COMPARING FORECASTS FROM DIFFERENT MODELS    #################
##########################################################################
num_rolls = length(pred.out) #number of forecasting rolls
num_test = 12 #forecasting horizon
num_turbs = 200 #number of turbines

p_asym = p_sep = p_per = truth    = v_asym = v_sep = betas  = vector(length = num_turbs*num_rolls*num_test)
asym.perc = matrix(nrow=num_turbs*num_rolls*num_test,ncol=6)
truth.p = 0;z = 1
adj_mat = matrix(nrow=num_turbs*num_rolls*num_test,ncol=2)
adj_mat_perc = matrix(nrow=num_turbs*num_rolls*num_test,ncol=6)

for (i in 1:num_rolls){
  #Recording forecasts
  p_asym[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,1])
  p_sep[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,4])
  p_per[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,2])
  truth[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,3])
  v_asym[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,5])
  v_sep[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,6])
  betas[z:(z+num_test*num_turbs-1)] = as.numeric(pred.out[[i]][,7])
  
  asym.perc[z:(z+num_test*num_turbs-1),1] = qnorm(p=0.4,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  asym.perc[z:(z+num_test*num_turbs-1),2] = qnorm(p=0.5,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  asym.perc[z:(z+num_test*num_turbs-1),3] = qnorm(p=0.6,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  asym.perc[z:(z+num_test*num_turbs-1),4] = qnorm(p=0.7,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  asym.perc[z:(z+num_test*num_turbs-1),5] = qnorm(p=0.73,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  asym.perc[z:(z+num_test*num_turbs-1),6] = qnorm(p=0.8,mean = p_asym[z:(z+num_test*num_turbs-1)],sd=sqrt(v_asym[z:(z+num_test*num_turbs-1)]))
  
  
  for(j in 1:dim(adj_mat)[2]){
    if(j == 1){jj = 8};if(j == 2){jj=10} #unconstrained/constrained calibration
    pred.out[[i]][1:400,jj] = pred.out[[i]][1:400,1] #first 2 hours - no calibration
    adj_mat[z:(z+num_test*num_turbs-1),j] = as.numeric(pred.out[[i]][,jj]) 
  }
  
  cquant = pmin(3, betas[z:(z+num_test*num_turbs-1)])
  cquant = pmax(-3,cquant)
  adj_mat_perc[z:(z+num_test*num_turbs-1),1] = asym.perc[z:(z+num_test*num_turbs-1),1] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),1] = asym.perc[z:(z+2*num_turbs-1),1]
  adj_mat_perc[z:(z+num_test*num_turbs-1),2] = asym.perc[z:(z+num_test*num_turbs-1),2] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),2] = asym.perc[z:(z+2*num_turbs-1),2]
  adj_mat_perc[z:(z+num_test*num_turbs-1),3] = asym.perc[z:(z+num_test*num_turbs-1),3] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),3] = asym.perc[z:(z+2*num_turbs-1),3]
  adj_mat_perc[z:(z+num_test*num_turbs-1),4] = asym.perc[z:(z+num_test*num_turbs-1),4] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),4] = asym.perc[z:(z+2*num_turbs-1),4]
  adj_mat_perc[z:(z+num_test*num_turbs-1),5] = asym.perc[z:(z+num_test*num_turbs-1),5] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),5] = asym.perc[z:(z+2*num_turbs-1),5]
  adj_mat_perc[z:(z+num_test*num_turbs-1),6] = asym.perc[z:(z+num_test*num_turbs-1),6] + cquant
  adj_mat_perc[z:(z+2*num_turbs-1),6] = asym.perc[z:(z+2*num_turbs-1),6]
  
  
  z = z + num_test*num_turbs
  st.ts = indices.out[[i]][2]+1
  end.ts = st.ts + num_test - 1
  sel.p = datas$Power[ (((st.ts-1)*num_turbs)+1): (end.ts*num_turbs)]
  truth.p = c(truth.p,sel.p)
  if(i %in% seq(1,num_rolls,100)){cat(paste(i,"out of",num_rolls,sep=" "),"\n")}
}
truth.p = truth.p[-1]

##Power forecasts
test.P = truth.p
c1_bound = adj_mat[,2]
c1_bound_perc = adj_mat_perc

Pestimations = list(length = N)
for (ii in 1:N){
  ind = seq(ii,(length(p_asym)-200)+ii,N)
  pred_a = p_asym[ind]
  pred_s = p_sep[ind]
  pred_p = p_per[ind]
  pred_c1 = c1_bound[ind]
  
  pred_q1 = c1_bound_perc[ind,1]
  pred_q2 = c1_bound_perc[ind,2]
  pred_q3 = c1_bound_perc[ind,3]
  pred_q4 = c1_bound_perc[ind,4]
  pred_q5 = c1_bound_perc[ind,5]
  pred_q6 = c1_bound_perc[ind,6]
  
  preda_q1 = asym.perc[ind,1]
  preda_q2 = asym.perc[ind,2]
  preda_q3 = asym.perc[ind,3]
  preda_q4 = asym.perc[ind,4]
  preda_q5 = asym.perc[ind,5]
  preda_q6 = asym.perc[ind,6]
  
  
  tr = truth[ind]
  powerpred_a = powerpred_s = powerpred_p = powerpred_c1  = vector(length = length(pred_a))
  powerpred_q1  = powerpred_q2  =powerpred_q3  =powerpred_q4  =powerpred_q5  =powerpred_q6  =vector(length = length(pred_a))
  powerpreda_q1  = powerpreda_q2  =powerpreda_q3  =powerpreda_q4  =powerpreda_q5  =powerpreda_q6  =vector(length = length(pred_a))
  
  powercurve.est = P.est[[ii]]
  powerpred_a[which(pred_a < vbin[1])] = 0
  powerpred_s[which(pred_s < vbin[1])] = 0
  powerpred_p[which(pred_p < vbin[1])] = 0
  powerpred_c1[which(pred_c1 < vbin[1])] = 0
  powerpred_q1[which(pred_q1 < vbin[1])] = 0
  powerpred_q2[which(pred_q2 < vbin[1])] = 0
  powerpred_q3[which(pred_q3 < vbin[1])] = 0
  powerpred_q4[which(pred_q4 < vbin[1])] = 0
  powerpred_q5[which(pred_q5 < vbin[1])] = 0
  powerpred_q6[which(pred_q6 < vbin[1])] = 0
  powerpreda_q1[which(preda_q1 < vbin[1])] = 0
  powerpreda_q2[which(preda_q2 < vbin[1])] = 0
  powerpreda_q3[which(preda_q3 < vbin[1])] = 0
  powerpreda_q4[which(preda_q4 < vbin[1])] = 0
  powerpreda_q5[which(preda_q5 < vbin[1])] = 0
  powerpreda_q6[which(preda_q6 < vbin[1])] = 0
  
  powerpred_a[which(pred_a > vr)] = max(powercurve.est)
  powerpred_s[which(pred_s > vr)] = max(powercurve.est)
  powerpred_p[which(pred_p > vr)] = max(powercurve.est)
  powerpred_c1[which(pred_c1 > vr)] = max(powercurve.est)
  powerpred_q1[which(pred_q1 > vr)] = max(powercurve.est)
  powerpred_q2[which(pred_q2 > vr)] = max(powercurve.est)
  powerpred_q3[which(pred_q3 > vr)] = max(powercurve.est)
  powerpred_q4[which(pred_q4 > vr)] = max(powercurve.est)
  powerpred_q5[which(pred_q5 > vr)] = max(powercurve.est)
  powerpred_q6[which(pred_q6 > vr)] = max(powercurve.est)
  powerpreda_q1[which(preda_q1 > vr)] = max(powercurve.est)
  powerpreda_q2[which(preda_q2 > vr)] = max(powercurve.est)
  powerpreda_q3[which(preda_q3 > vr)] = max(powercurve.est)
  powerpreda_q4[which(preda_q4 > vr)] = max(powercurve.est)
  powerpreda_q5[which(preda_q5 > vr)] = max(powercurve.est)
  powerpreda_q6[which(preda_q6 > vr)] = max(powercurve.est)
  
  #Based on Binning method
  for (i in 1:(length(vbin)-1)){
    powerpred_a[which(pred_a >= vbin[i] & pred_a < vbin[i+1])] = powercurve.est[i]
    powerpred_s[which(pred_s >= vbin[i] & pred_s < vbin[i+1])] = powercurve.est[i]
    powerpred_p[which(pred_p >= vbin[i] & pred_p < vbin[i+1])] = powercurve.est[i]
    powerpred_c1[which(pred_c1 >= vbin[i] & pred_c1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q1[which(pred_q1 >= vbin[i] & pred_q1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q2[which(pred_q2 >= vbin[i] & pred_q2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q3[which(pred_q3 >= vbin[i] & pred_q3 < vbin[i+1])] = powercurve.est[i]
    powerpred_q4[which(pred_q4 >= vbin[i] & pred_q4 < vbin[i+1])] = powercurve.est[i]
    powerpred_q5[which(pred_q5 >= vbin[i] & pred_q5 < vbin[i+1])] = powercurve.est[i]
    powerpred_q6[which(pred_q6 >= vbin[i] & pred_q6 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q1[which(preda_q1 >= vbin[i] & preda_q1 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q2[which(preda_q2 >= vbin[i] & preda_q2 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q3[which(preda_q3 >= vbin[i] & preda_q3 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q4[which(preda_q4 >= vbin[i] & preda_q4 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q5[which(preda_q5 >= vbin[i] & preda_q5 < vbin[i+1])] = powercurve.est[i]
    powerpreda_q6[which(preda_q6 >= vbin[i] & preda_q6 < vbin[i+1])] = powercurve.est[i]
    
    
  }
  
  truetest = test.P[ind]
  
  mat.out = matrix(ncol=17,nrow=length(truetest))
  mat.out[,1] = powerpred_a
  mat.out[,2] = powerpred_s
  mat.out[,3] = powerpred_p
  mat.out[,4] = truetest
  mat.out[,5] = powerpred_c1
  mat.out[,6] = powerpred_q1
  mat.out[,7] = powerpred_q2
  mat.out[,8] = powerpred_q3
  mat.out[,9] = powerpred_q4
  mat.out[,10] = powerpred_q5
  mat.out[,11] = powerpred_q6
  mat.out[,12] = powerpreda_q1
  mat.out[,13] = powerpreda_q2
  mat.out[,14] = powerpreda_q3
  mat.out[,15] = powerpreda_q4
  mat.out[,16] = powerpreda_q5
  mat.out[,17] = powerpreda_q6
  Pestimations[[ii]] = mat.out
  if (ii %in% seq(1,num_turbs,20)){cat(ii,"  ")}
}

####PCE
ppreds = matrix(ncol=16,nrow=length(p_asym))
ppreds[,1] = p_asym
ppreds[,2] = p_sep
ppreds[,3] = p_per
ppreds[,4] = c1_bound
ppreds[,5:10] = asym.perc
ppreds[,11:16] = c1_bound_perc

alphavec = sort(c(seq(0.4,0.8,0.1),0.73))
errvec = matrix(ncol = length(alphavec),nrow=dim(ppreds)[2])
for(pp in 1:5){
  for(iter in 1:length(alphavec)){
    under=0;over=0
    alpha = alphavec[iter]
    if(pp == 1){response = asym.perc[,iter];index.p=iter+11}
    if(pp == 2){response = ppreds[,2];index.p = 2}
    if(pp == 3){response = ppreds[,3]; index.p = 3}
    if(pp == 4){response = c1_bound_perc[,iter]; index.p = iter + 5}
    if(pp == 5){response = c1_bound;index.p = 5}
    for(i in 1:200){
      ind = seq(i,(length(response)-200)+i,200)
      res = response[ind]
      tt = truth[ind]
      
      response.p = Pestimations[[i]][,index.p]
      response.true=Pestimations[[i]][,4] #true powers 
      
      
      out1 = which(response.true < 0)
      out2 = which(is.na(response.true) == T)
      out3 = c(which(res<vci & tt<vci),which(res>vr & tt>vr)) #remove boundary values
      
      out = unique(c(out1,out2,out3))
      res = res[-out]
      response.p= response.p[-out]
      response.true=response.true[-out]
      tt = tt[-out]
      
      
      ans=res-tt
      
      
      over.id=which(ans>=0)
      under.id=which(ans<0)
      
      under=c(under,response.true[under.id] - response.p[under.id])
      over=c(over,response.p[over.id] - response.true[over.id])
    }
    
    errvec[pp,iter] = mean(c((alpha*under),((1-alpha)*over)))
    cat(iter," ")
  }
  cat(pp,"\n")
}
PCE_mat = matrix(nrow=7,ncol=length(alphavec))
rownames(PCE_mat)=c("ASYM","SEP","PER","RSAR","MSAR","MSVAR","PRS")
colnames(PCE_mat)=as.character(sort(c(seq(0.4,0.8,0.1),0.73)))
PCE_mat[1,] = errvec[1,] #ASYM
#PCE_mat[2,] = errvec[2,]
PCE_mat[3,] = errvec[3,] #PER
PCE_mat[7,] = errvec[4,] #ADJ


###################SEP results###################
load("Code Used in the Book/Chapter4/temp/SEP/predout_test.R")
load("Code Used in the Book/Chapter4/temp/SEP/indicesout_test.R")

#Computing 12-hr average for wind speed
num_test = 12
p_sep2  = truth = truth.p = v_sep2 = 0
sep.perc = matrix(nrow=num_rolls*num_test*num_turbs,ncol=6)
z = 1
for (i in 1:num_rolls){
  p_sep2 = c(p_sep2,as.numeric(pred.out[[i]][,1]))
  truth = c(truth,as.numeric(pred.out[[i]][,3]))
  v_sep2 = c(v_sep2,as.numeric(pred.out[[i]][,5]))
  
  if(i == 1){p_sep2 = p_sep2[-1];truth=truth[-1];v_sep2 = v_sep2[-1]}
  
  sep.perc[z:(z+num_test*num_turbs-1),1] = qnorm(p=0.4,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  sep.perc[z:(z+num_test*num_turbs-1),2] = qnorm(p=0.5,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  sep.perc[z:(z+num_test*num_turbs-1),3] = qnorm(p=0.6,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  sep.perc[z:(z+num_test*num_turbs-1),4] = qnorm(p=0.7,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  sep.perc[z:(z+num_test*num_turbs-1),5] = qnorm(p=0.73,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  sep.perc[z:(z+num_test*num_turbs-1),6] = qnorm(p=0.8,mean = p_sep2[z:(z+num_test*num_turbs-1)],sd=sqrt(v_sep2[z:(z+num_test*num_turbs-1)]))
  
  
  st.ts = indices.out[[i]][2]+1
  end.ts = st.ts + num_test - 1
  sel.p = datas$Power[ (((st.ts-1)*200)+1): (end.ts*200)]
  truth.p = c(truth.p,sel.p)
  z = z + num_test*num_turbs
}
truth.p = truth.p[-1]

#####SEP2: projecting to power domain
num_test = 12
test.P = truth.p
Pestimations = list(length = 200)
for (ii in 1:200){
  ind = seq(ii,(length(p_sep2)-200)+ii,200)
  pred_s2 = p_sep2[ind]
  pred_q1 = sep.perc[ind,1]
  pred_q2 = sep.perc[ind,2]
  pred_q3 = sep.perc[ind,3]
  pred_q4 = sep.perc[ind,4]
  pred_q5 = sep.perc[ind,5]
  pred_q6 = sep.perc[ind,6]
  
  
  
  tr = truth[ind]
  powerpred_s2 = vector(length = length(pred_s2))
  powerpred_q1 = powerpred_q2 = powerpred_q3 = powerpred_q4 = powerpred_q5 = powerpred_q6 = vector(length = length(pred_s2))
  powercurve.est = P.est[[ii]]
  powerpred_s2[which(pred_s2 < vbin[1])] = 0
  powerpred_s2[which(pred_s2 > vr)] = max(powercurve.est)
  
  powerpred_q1[which(pred_q1 < vbin[1])] = 0
  powerpred_q1[which(pred_q1 > vr)] = max(powercurve.est)
  powerpred_q2[which(pred_q2 < vbin[1])] = 0
  powerpred_q2[which(pred_q2 > vr)] = max(powercurve.est)
  powerpred_q3[which(pred_q3 < vbin[1])] = 0
  powerpred_q3[which(pred_q3 > vr)] = max(powercurve.est)
  powerpred_q4[which(pred_q4 < vbin[1])] = 0
  powerpred_q4[which(pred_q4 > vr)] = max(powercurve.est)
  powerpred_q5[which(pred_q5 < vbin[1])] = 0
  powerpred_q5[which(pred_q5 > vr)] = max(powercurve.est)
  powerpred_q6[which(pred_q6 < vbin[1])] = 0
  powerpred_q6[which(pred_q6 > vr)] = max(powercurve.est)
  
  #Based on Binning method
  for (i in 1:(length(vbin)-1)){
    powerpred_s2[which(pred_s2 >= vbin[i] & pred_s2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q1[which(pred_q1 >= vbin[i] & pred_q1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q2[which(pred_q2 >= vbin[i] & pred_q2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q3[which(pred_q3 >= vbin[i] & pred_q3 < vbin[i+1])] = powercurve.est[i]
    powerpred_q4[which(pred_q4 >= vbin[i] & pred_q4 < vbin[i+1])] = powercurve.est[i]
    powerpred_q5[which(pred_q5 >= vbin[i] & pred_q5 < vbin[i+1])] = powercurve.est[i]
    powerpred_q6[which(pred_q6 >= vbin[i] & pred_q6 < vbin[i+1])] = powercurve.est[i]
    
  }
  
  truetest = test.P[ind]
  
  mat.out = matrix(ncol=8,nrow=length(truetest))
  mat.out[,1] = powerpred_s2
  mat.out[,2] = truetest
  mat.out[,3] = powerpred_q1
  mat.out[,4] = powerpred_q2
  mat.out[,5] = powerpred_q3
  mat.out[,6] = powerpred_q4
  mat.out[,7] = powerpred_q5
  mat.out[,8] = powerpred_q6
  Pestimations[[ii]] = mat.out
  if (ii %in% seq(1,200,20)){cat(ii,"  ")}
}

####PCE
ppreds = matrix(ncol=7,nrow=length(p_asym))
ppreds[,1] = p_sep2
ppreds[,2:7] = sep.perc[,1:6]

errvec = matrix(ncol = length(alphavec),nrow=dim(ppreds)[2])
for(pp in 1:2){
  for(iter in 1:length(alphavec)){
    under=0;over=0
    alpha = alphavec[iter]
    
    if(pp == 1){response = sep.perc[,iter];index.p=iter+2}
    if(pp == 2){response = ppreds[,1];index.p = 1}
    
    for(i in 1:200){
      ind = seq(i,(length(response)-200)+i,200)
      res = response[ind]
      tt = truth[ind]
      
      response.p = Pestimations[[i]][,index.p]
      response.true=Pestimations[[i]][,2] #true powers 
      
      
      out1 = which(response.true < 0)
      out2 = which(is.na(response.true) == T)
      out3 = c(which(res<vci & tt<vci),which(res>vr & tt>vr)) #remove boundary values
      
      out = unique(c(out1,out2,out3))
      res = res[-out]
      response.p= response.p[-out]
      response.true=response.true[-out]
      tt = tt[-out]
      
      
      ans=res-tt
      over.id=which(ans>=0)
      under.id=which(ans<0)
      
      under=c(under,response.true[under.id] - response.p[under.id])
      over=c(over,response.p[over.id] - response.true[over.id])
    }
    
    errvec[pp,iter] = mean(c((alpha*under),((1-alpha)*over)))
    cat(iter," ")
  }
  cat(pp,"\n")
}
PCE_mat[2,] = errvec[1,] #SEP
PCE_mat

###################RSAR###################
setwd("Code Used in the Book/Chapter4/temp/RSAR")
load("predout_test.R")
load("indicesout_test.R")
load("paramsout_test.R")

#Computing 12-hr average for wind speed
num_test = 12
p_rs1 = p_rs2  = truth = truth.p = 0
rsar.perc = matrix(nrow=num_test*num_rolls*N,ncol=6)
zz = 1
for (i in 1:num_rolls){
  p_rs1 = c(p_rs1,as.numeric(pred.out[[i]][,1]))
  truth = c(truth,as.numeric(pred.out[[i]][,3]))
  
  #quantile data
  if(i == 1){p_rs1 = p_rs1[-1];truth = truth[-1]}
  
  mtt = matrix(nrow=2400,ncol=6)
  for(turb in 1:N){
    est_variance = params.out[[i]][turb,3] #variance for the turbine
    est_mean = p_rs1[zz:(zz+2399)] #vector of means for every horizon
    est_mean = est_mean[seq(turb,2400,200)]
    mtt[seq(turb,2400,200),1] = qnorm(p=0.4,mean=est_mean,sd=sqrt(est_variance))
    mtt[seq(turb,2400,200),2] = qnorm(p=0.5,mean=est_mean,sd=sqrt(est_variance))
    mtt[seq(turb,2400,200),3] = qnorm(p=0.6,mean=est_mean,sd=sqrt(est_variance))
    mtt[seq(turb,2400,200),4] = qnorm(p=0.7,mean=est_mean,sd=sqrt(est_variance))
    mtt[seq(turb,2400,200),5] = qnorm(p=0.73,mean=est_mean,sd=sqrt(est_variance))
    mtt[seq(turb,2400,200),6] = qnorm(p=0.8,mean=est_mean,sd=sqrt(est_variance))
  }
  rsar.perc[zz:(zz+2399),1:6] = mtt
  zz =zz + 2400
  st.ts = indices.out[[i]][2]+1
  end.ts = st.ts + num_test - 1
  sel.p = datas$Power[ (((st.ts-1)*200)+1): (end.ts*200)]
  truth.p = c(truth.p,sel.p)
}
truth.p = truth.p[-1]

#####RSAR: projecting to power domain
num_test = 12
test.P = truth.p
Pestimations = list(length = 200)
for (ii in 1:200){
  ind = seq(ii,(length(p_rs1)-200)+ii,200)
  pred_rs1 = p_rs1[ind]
  
  pred_q1 = rsar.perc[ind,1]
  pred_q2 = rsar.perc[ind,2]
  pred_q3 = rsar.perc[ind,3]
  pred_q4 = rsar.perc[ind,4]
  pred_q5 = rsar.perc[ind,5]
  pred_q6 = rsar.perc[ind,6]
  
  tr = truth[ind]
  powerpred_rs1 = vector(length = length(pred_rs1))
  powerpred_q1 = powerpred_q2 = powerpred_q3 = powerpred_q4 = powerpred_q5 = powerpred_q6 = vector(length = length(pred_rs1))
  
  powercurve.est = P.est[[ii]]
  powerpred_rs1[which(pred_rs1 < vbin[1])] = 0
  powerpred_rs1[which(pred_rs1 > vr)] = max(powercurve.est)
  
  powerpred_q1[which(pred_q1 < vbin[1])] = 0
  powerpred_q1[which(pred_q1 > vr)] = max(powercurve.est)
  powerpred_q2[which(pred_q2 < vbin[1])] = 0
  powerpred_q2[which(pred_q2 > vr)] = max(powercurve.est)
  powerpred_q3[which(pred_q3 < vbin[1])] = 0
  powerpred_q3[which(pred_q3 > vr)] = max(powercurve.est)
  powerpred_q4[which(pred_q4 < vbin[1])] = 0
  powerpred_q4[which(pred_q4 > vr)] = max(powercurve.est)
  powerpred_q5[which(pred_q5 < vbin[1])] = 0
  powerpred_q5[which(pred_q5 > vr)] = max(powercurve.est)
  powerpred_q6[which(pred_q6 < vbin[1])] = 0
  powerpred_q6[which(pred_q6 > vr)] = max(powercurve.est)
  
  
  #Based on Binning method
  for (i in 1:(length(vbin)-1)){
    powerpred_rs1[which(pred_rs1 >= vbin[i] & pred_rs1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q1[which(pred_q1 >= vbin[i] & pred_q1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q2[which(pred_q2 >= vbin[i] & pred_q2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q3[which(pred_q3 >= vbin[i] & pred_q3 < vbin[i+1])] = powercurve.est[i]
    powerpred_q4[which(pred_q4 >= vbin[i] & pred_q4 < vbin[i+1])] = powercurve.est[i]
    powerpred_q5[which(pred_q5 >= vbin[i] & pred_q5 < vbin[i+1])] = powercurve.est[i]
    powerpred_q6[which(pred_q6 >= vbin[i] & pred_q6 < vbin[i+1])] = powercurve.est[i]
    
  }
  
  truetest = test.P[ind]
  
  mat.out = matrix(ncol=8,nrow=length(truetest))
  mat.out[,1] = powerpred_rs1
  mat.out[,2] = truetest
  mat.out[,3] = powerpred_q1
  mat.out[,4] = powerpred_q2
  mat.out[,5] = powerpred_q3
  mat.out[,6] = powerpred_q4
  mat.out[,7] = powerpred_q5
  mat.out[,8] = powerpred_q6
  Pestimations[[ii]] = mat.out
  if (ii %in% seq(1,200,20)){cat(ii,"  ")}
}

####PCE
ppreds = matrix(ncol=7,nrow=length(p_asym))
ppreds[,1] = p_rs1
ppreds[,2:7] = rsar.perc
Pestimations[[1]][1,]

errvec = matrix(ncol = length(alphavec),nrow=dim(ppreds)[2])
for(pp in 1:2){
  for(iter in 1:length(alphavec)){
    under=0;over=0
    alpha = alphavec[iter]
    
    if(pp == 1){response = rsar.perc[,iter];index.p=iter+2}
    if(pp == 2){response = ppreds[,1];index.p = 1}
    
    for(i in 1:200){
      ind = seq(i,(length(response)-200)+i,200)
      res = response[ind]
      tt = truth[ind]
      
      response.p = Pestimations[[i]][,index.p]
      response.true=Pestimations[[i]][,2] #true powers 
      
      
      out1 = which(response.true < 0)
      out2 = which(is.na(response.true) == T)
      out3 = c(which(res<vci & tt<vci),which(res>vr & tt>vr)) #remove boundary values
      
      out = unique(c(out1,out2,out3))
      res = res[-out]
      response.p= response.p[-out]
      response.true=response.true[-out]
      tt = tt[-out]
      
      
      ans=res-tt
      over.id=which(ans>=0)
      under.id=which(ans<0)
      
      under=c(under,response.true[under.id] - response.p[under.id])
      over=c(over,response.p[over.id] - response.true[over.id])
    }
    
    errvec[pp,iter] = mean(c((alpha*under),((1-alpha)*over)))
    cat(iter," ")
  }
  cat(pp,"\n")
}
PCE_mat[4,] = errvec[1,] #RSAR
PCE_mat

###################MSAR###################
setwd("H:/DingBook/Files Sharing/Code Used in the Book/Chapter4/temp/MSAR")
load("predout_test.R")
load("indicesout_test.R")
load("paramsout_test.R")
load("paramsout2_test.R")


#Function to numerically compute the percentile of the mixture distribution
library(MASS)
FF = function(nsams, mm, ss, ww,qq){
  sam = mvrnorm(n=nsams,mu=mm,Sigma=diag(ss^2))
  mixsam = sam %*% ww
  val = quantile(mixsam,qq)
  return(val)
}
FF(n=1000,mm=params.out[[1]][seq(1,1200,N),1+4],ss=sqrt(params.out[[1]][seq(1,1200,N),3]),ww=params.out2[[1]][[1]][1,],qq=0.5)
as.numeric(pred.out[[1]][1,1])

#Computing 12-hr average for wind speed
num_test = 12
p_mrs1 = p_mrs2  = truth = truth.p = 0
msar.perc = matrix(nrow=N*num_test*num_rolls,ncol=6)
zz = 1
for (i in 1:num_rolls){
  p_mrs1 = c(p_mrs1,as.numeric(pred.out[[i]][,1]))
  p_mrs2 = c(p_mrs2,as.numeric(pred.out[[i]][,4]))
  truth = c(truth,as.numeric(pred.out[[i]][,3]))
  
  
  #quantile data
  if(i == 1){p_mrs1 = p_mrs1[-1];p_mrs2 = p_mrs2[-1];truth = truth[-1]}
  
  tempmat = matrix(nrow=2400,ncol=6)
  for(hh in 1:num_test){
    for(turb in 1:N){
      means.pred = params.out[[i]][seq(turb,1200,N),hh+4]
      vars.pred = params.out[[i]][seq(turb,1200,N),3]
      weights.pred = params.out2[[i]][[turb]][hh,]
      tempmat[(turb+((hh-1)*N)),1:6] = FF(1000,means.pred,sqrt(vars.pred),weights.pred,c(0.4,0.5,0.6,0.7,0.73,0.8))
    }
  }
  msar.perc[(zz:(zz+2399)),1:6] = tempmat
  zz = zz + 2400
  
  st.ts = indices.out[[i]][2]+1
  end.ts = st.ts + num_test - 1
  sel.p = datas$Power[ (((st.ts-1)*200)+1): (end.ts*200)]
  truth.p = c(truth.p,sel.p)
  if (i %in% seq(1,1400,10)){cat(paste(i,"out of 1339",sep=" ")," ")}
}
truth.p = truth.p[-1]

#####MSAR: projecting to power domain
num_test = 12
test.P = truth.p

Pestimations = list(length = 200)
for (ii in 1:200){
  ind = seq(ii,(length(p_mrs1)-200)+ii,200)
  pred_mrs1 = p_mrs1[ind]
  pred_mrs2 = p_mrs2[ind]
  
  pred_q1 = msar.perc[ind,1]
  pred_q2 = msar.perc[ind,2]
  pred_q3 = msar.perc[ind,3]
  pred_q4 = msar.perc[ind,4]
  pred_q5 = msar.perc[ind,5]
  pred_q6 = msar.perc[ind,6]
  
  tr = truth[ind]
  powerpred_mrs1 = vector(length = length(pred_mrs1))
  powerpred_mrs2 = vector(length = length(pred_mrs2))
  powerpred_q1 = powerpred_q2 = powerpred_q3 = powerpred_q4 = powerpred_q5 = powerpred_q6 = vector(length = length(pred_mrs1))
  
  
  powercurve.est = P.est[[ii]]
  powerpred_mrs1[which(pred_mrs1 < vbin[1])] = 0
  powerpred_mrs1[which(pred_mrs1 > vr)] = max(powercurve.est)
  powerpred_mrs2[which(pred_mrs2 < vbin[1])] = 0
  powerpred_mrs2[which(pred_mrs2 > vr)] = max(powercurve.est)
  
  powerpred_q1[which(pred_q1 < vbin[1])] = 0
  powerpred_q1[which(pred_q1 > vr)] = max(powercurve.est)
  powerpred_q2[which(pred_q2 < vbin[1])] = 0
  powerpred_q2[which(pred_q2 > vr)] = max(powercurve.est)
  powerpred_q3[which(pred_q3 < vbin[1])] = 0
  powerpred_q3[which(pred_q3 > vr)] = max(powercurve.est)
  powerpred_q4[which(pred_q4 < vbin[1])] = 0
  powerpred_q4[which(pred_q4 > vr)] = max(powercurve.est)
  powerpred_q5[which(pred_q5 < vbin[1])] = 0
  powerpred_q5[which(pred_q5 > vr)] = max(powercurve.est)
  powerpred_q6[which(pred_q6 < vbin[1])] = 0
  powerpred_q6[which(pred_q6 > vr)] = max(powercurve.est)
  
  #Based on Binning method
  for (i in 1:(length(vbin)-1)){
    powerpred_mrs1[which(pred_mrs1 >= vbin[i] & pred_mrs1 < vbin[i+1])] = powercurve.est[i]
    powerpred_mrs2[which(pred_mrs2 >= vbin[i] & pred_mrs2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q1[which(pred_q1 >= vbin[i] & pred_q1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q2[which(pred_q2 >= vbin[i] & pred_q2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q3[which(pred_q3 >= vbin[i] & pred_q3 < vbin[i+1])] = powercurve.est[i]
    powerpred_q4[which(pred_q4 >= vbin[i] & pred_q4 < vbin[i+1])] = powercurve.est[i]
    powerpred_q5[which(pred_q5 >= vbin[i] & pred_q5 < vbin[i+1])] = powercurve.est[i]
    powerpred_q6[which(pred_q6 >= vbin[i] & pred_q6 < vbin[i+1])] = powercurve.est[i]
    
  }
  
  truetest = test.P[ind]
  
  mat.out = matrix(ncol=9,nrow=length(truetest))
  mat.out[,1] = powerpred_mrs1
  mat.out[,2] = truetest
  mat.out[,3] = powerpred_mrs2
  mat.out[,4] = powerpred_q1
  mat.out[,5] = powerpred_q2
  mat.out[,6] = powerpred_q3
  mat.out[,7] = powerpred_q4
  mat.out[,8] = powerpred_q5
  mat.out[,9] = powerpred_q6
  Pestimations[[ii]] = mat.out
  if (ii %in% seq(1,200,20)){cat(ii,"  ")}
}

####PCE
ppreds = matrix(ncol=8,nrow=length(p_asym))
ppreds[,1] = p_mrs1
ppreds[,2] = p_mrs2
ppreds[,3:8] = msar.perc

Pestimations[[1]][1,] #make sure where the true powers are stored and update accordingly
PCE_mat
errvec = matrix(ncol = length(alphavec),nrow=dim(ppreds)[2])
alphavec

for(pp in 1:2){
    for(iter in 1:length(alphavec)){
    under=0;over=0
    alpha = alphavec[iter]
    
    if(pp == 1){response = msar.perc[,iter];index.p=iter+2}
    if(pp == 2){response = ppreds[,1];index.p = 1}
    
    for(i in 1:200){
      ind = seq(i,(length(response)-200)+i,200)
      res = response[ind]
      tt = truth[ind]
      
      response.p = Pestimations[[i]][,index.p]
      response.true=Pestimations[[i]][,2] #true powers 
      
      
      out1 = which(response.true < 0)
      out2 = which(is.na(response.true) == T)
      out3 = c(which(res<vci & tt<vci),which(res>vr & tt>vr)) #remove boundary values
      
      out = unique(c(out1,out2,out3))
      res = res[-out]
      response.p= response.p[-out]
      response.true=response.true[-out]
      tt = tt[-out]
      
      
      ans=res-tt
      over.id=which(ans>=0)
      under.id=which(ans<0)
      
      under=c(under,response.true[under.id] - response.p[under.id])
      over=c(over,response.p[over.id] - response.true[over.id])
    }
    
    errvec[pp,iter] = mean(c((alpha*under),((1-alpha)*over)))
    cat(iter," ")
  }
  cat(pp,"\n")
}
PCE_mat[5,] = errvec[1,] #MSAR
PCE_mat

##########################################################################
########################## MSVAR results  #################################
##########################################################################
setwd("H:/DingBook/Files Sharing/Code Used in the Book/Chapter4/temp/MSVAR")
load("predout_test.R")
load("indicesout_test.R")
load("paramsout_test.R")
load("paramsout2_test.R")
load("paramsout3_test.R")

library(fields)
loc = coords[,3:2]
spatdist = (rdist.earth(loc,miles=F))#distance 

#Computing 12-hr average for wind speed
num_test = 12
p_vmrs1 = p_vmrs2  = truth = truth.p = 0
msvar.perc = matrix(nrow=N*num_test*num_rolls,ncol=6)
zz = 1

cat("PROCESSING - THIS MAY TAKE SOME TIME","\n")
for (i in 1:num_rolls){
  #i = 1
  p_vmrs1 = c(p_vmrs1,as.numeric(pred.out[[i]][,1]))
  p_vmrs2 = c(p_vmrs2,as.numeric(pred.out[[i]][,4]))
  truth = c(truth,as.numeric(pred.out[[i]][,3]))
  
  
  #quantile data
  if(i == 1){p_vmrs1 = p_vmrs1[-1];p_vmrs2 = p_vmrs2[-1];truth = truth[-1]}
  
  #start_time = Sys.time()
  aa = 1
  tempmat = matrix(nrow=2400,ncol=6)
  for(hh in 1:12){
    tt = 1
    sam = matrix(nrow=1000,ncol=6)
    for(turb in 1:N){
      for(reg in 1:6){
        #reg = 5
        inform_n = head(order(spatdist[,turb]),5) #informative neighborhood
        sam[,reg] = mvrnorm(1000,mu=params.out[[i]][((reg-1)*N)+inform_n,30+hh],Sigma=params.out2[[i]][[reg]][tt:(tt+4),1:5])[,1]
      }
      mixsam = sam %*% params.out3[[i]][hh,1:6]
      tempmat[aa,1:6] = quantile(mixsam,c(0.4,0.5,0.6,0.7,0.73,0.8),na.rm=T)
      tt = tt + 5
      aa = aa + 1
      
    }
  }
  msvar.perc[zz:(zz+2399),1:6] = tempmat
  zz = zz + 2400
  
  
  st.ts = indices.out[[i]][2]+1
  end.ts = st.ts + num_test - 1
  sel.p = datas$Power[ (((st.ts-1)*200)+1): (end.ts*200)]
  truth.p = c(truth.p,sel.p)
  
  if (i %in% seq(1,1400,5)){cat(paste(i,"out of 1339  ",sep=" "),"")}
}
truth.p = truth.p[-1]

#####MSVAR: projecting to power domain
num_test = 12
test.P = truth.p
Pestimations = list(length = 200)
for (ii in 1:200){
  ind = seq(ii,(length(p_vmrs1)-200)+ii,200)
  pred_vmrs1 = p_vmrs1[ind]
  pred_vmrs2 = p_vmrs2[ind]
  
  pred_q1 = msvar.perc[ind,1]
  pred_q2 = msvar.perc[ind,2]
  pred_q3 = msvar.perc[ind,3]
  pred_q4 = msvar.perc[ind,4]
  pred_q5 = msvar.perc[ind,5]
  pred_q6 = msvar.perc[ind,6]
  
  tr = truth[ind]
  powerpred_vmrs1 = vector(length = length(pred_vmrs1))
  powerpred_vmrs2 = vector(length = length(pred_vmrs2))
  powerpred_q1 = powerpred_q2 = powerpred_q3 = powerpred_q4 = powerpred_q5 = powerpred_q6 = vector(length = length(pred_vmrs1))
  
  powercurve.est = P.est[[ii]]
  powerpred_vmrs1[which(pred_vmrs1 < vbin[1])] = 0
  powerpred_vmrs1[which(pred_vmrs1 > vr)] = max(powercurve.est)
  powerpred_vmrs2[which(pred_vmrs2 < vbin[1])] = 0
  powerpred_vmrs2[which(pred_vmrs2 > vr)] = max(powercurve.est)
  
  powerpred_q1[which(pred_q1 < vbin[1])] = 0
  powerpred_q1[which(pred_q1 > vr)] = max(powercurve.est)
  powerpred_q2[which(pred_q2 < vbin[1])] = 0
  powerpred_q2[which(pred_q2 > vr)] = max(powercurve.est)
  powerpred_q3[which(pred_q3 < vbin[1])] = 0
  powerpred_q3[which(pred_q3 > vr)] = max(powercurve.est)
  powerpred_q4[which(pred_q4 < vbin[1])] = 0
  powerpred_q4[which(pred_q4 > vr)] = max(powercurve.est)
  powerpred_q5[which(pred_q5 < vbin[1])] = 0
  powerpred_q5[which(pred_q5 > vr)] = max(powercurve.est)
  powerpred_q6[which(pred_q6 < vbin[1])] = 0
  powerpred_q6[which(pred_q6 > vr)] = max(powercurve.est)
  
  #Based on Binning method
  for (i in 1:(length(vbin)-1)){
    powerpred_vmrs1[which(pred_vmrs1 >= vbin[i] & pred_vmrs1 < vbin[i+1])] = powercurve.est[i]
    powerpred_vmrs2[which(pred_vmrs2 >= vbin[i] & pred_vmrs2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q1[which(pred_q1 >= vbin[i] & pred_q1 < vbin[i+1])] = powercurve.est[i]
    powerpred_q2[which(pred_q2 >= vbin[i] & pred_q2 < vbin[i+1])] = powercurve.est[i]
    powerpred_q3[which(pred_q3 >= vbin[i] & pred_q3 < vbin[i+1])] = powercurve.est[i]
    powerpred_q4[which(pred_q4 >= vbin[i] & pred_q4 < vbin[i+1])] = powercurve.est[i]
    powerpred_q5[which(pred_q5 >= vbin[i] & pred_q5 < vbin[i+1])] = powercurve.est[i]
    powerpred_q6[which(pred_q6 >= vbin[i] & pred_q6 < vbin[i+1])] = powercurve.est[i]
    
  }
  
  truetest = test.P[ind]
  
  mat.out = matrix(ncol=9,nrow=length(truetest))
  mat.out[,1] = powerpred_vmrs1
  mat.out[,2] = truetest
  mat.out[,3] = powerpred_vmrs2
  mat.out[,4] = powerpred_q1
  mat.out[,5] = powerpred_q2
  mat.out[,6] = powerpred_q3
  mat.out[,7] = powerpred_q4
  mat.out[,8] = powerpred_q5
  mat.out[,9] = powerpred_q6
  
  Pestimations[[ii]] = mat.out
  if (ii %in% seq(1,200,20)){cat(ii,"  ")}
}

####PCE
ppreds = matrix(ncol=8,nrow=length(p_asym))
ppreds[,1] = p_vmrs1
ppreds[,2] = p_vmrs2
ppreds[,3:8] = msvar.perc
errvec = matrix(ncol = length(alphavec),nrow=dim(ppreds)[2])

for(pp in 1:2){
    for(iter in 1:length(alphavec)){
    under=0;over=0
    alpha = alphavec[iter]
    
    if(pp == 1){response = msar.perc[,iter];index.p=iter+2}
    if(pp == 2){response = ppreds[,1];index.p = 1}
    
    for(i in 1:200){
      ind = seq(i,(length(response)-200)+i,200)
      res = response[ind]
      tt = truth[ind]
      
      response.p = Pestimations[[i]][,index.p]
      response.true=Pestimations[[i]][,2] #true powers 
      
      
      out1 = which(response.true < 0)
      out2 = which(is.na(response.true) == T)
      out3 = c(which(res<vci & tt<vci),which(res>vr & tt>vr)) #remove boundary values
      
      out = unique(c(out1,out2,out3))
      res = res[-out]
      response.p= response.p[-out]
      response.true=response.true[-out]
      tt = tt[-out]
      
      
      ans=res-tt
      over.id=which(ans>=0)
      under.id=which(ans<0)
      
      under=c(under,response.true[under.id] - response.p[under.id])
      over=c(over,response.p[over.id] - response.true[over.id])
    }
    
    errvec[pp,iter] = mean(c((alpha*under),((1-alpha)*over)))
    cat(iter," ")
  }
  cat(pp,"\n")
}
PCE_mat[6,] = errvec[1,] #MSVAR
PCE_mat

##Saving final table
write.table(PCE_mat[,2:6],file="H:/DingBook/Files Sharing/Code Used in the Book/Chapter4/Table4.6.txt",col.names = T,row.names = T)
